---
title: MediaRecorderErrorEvent.error
slug: Web/API/MediaRecorderErrorEvent/error
tags:
  - API
  - Error
  - Error Handling
  - MediaRecordingErrorEvent
  - MediaStream Recording
  - MediaStream Recording API
  - Property
  - Reference
---
<div>{{APIRef("MediaStream Recording")}}</div>

<p>The read-only <code>error</code> property in the <strong>{{domxref("MediaRecorderErrorEvent")}}</strong> interface is a {{domxref("DOMException")}} object providing details about the exception that was thrown by a {{domxref("MediaRecorder")}} instance.</p>

<p>When a <code>MediaRecorderErrorEvent</code> occurs, you can determine to some extent what went wrong by examining the <code>error</code> property within the <code>MediaRecorderErrorEvent</code> received by the <code>MediaRecorder</code>'s {{event("error")}} event handler, {{domxref("MediaRecorder.onerror", "onerror")}}.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><em>error</em> = <em>MediaRecorderErrorEvent</em>.error;
</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMException")}} describing the error represented by the event. The error's {{domxref("DOMException.name", "name")}} property's value may be any exception that makes sense during the handling of media recording, including these specifically identified by the specification. The descriptions here are generic ones; you'll find more specific ones to various scenarios in which they may occur in the corresponding method references.</p>

<dl>
 <dt><code>InvalidStateError</code></dt>
 <dd>An operation was attempted in a context in which it isn't allowed, or a request has been made on an object that's deleted or removed.</dd>
 <dt><code>NotSupportedError</code></dt>
 <dd>A <code>MediaRecorder</code> couldn't be created because the specified options weren't valid. The <code>message</code> atttribute should provide additional information, if it exists.</dd>
 <dt><code>SecurityError</code></dt>
 <dd>The {{domxref("MediaStream")}} is configured to disallow recording. This may be the case, for example, with sources obtained using {{domxref("MediaDevices.getUserMedia", "getUserMedia()")}} when the user denies permission to use an input device.  This also happens when a {{domxref("MediaStreamTrack")}} within the stream is marked as {{domxref("MediaStreamTrack.isolated", "isolated")}} due to the {{domxref("MediaStreamConstraints.peerIdentity", "peerIdentity")}} constraint on the source stream.</dd>
 <dt><code>InvalidModificationError</code></dt>
 <dd>The number of tracks on the stream being recorded has changed. You can't add or remove tracks while recording media.</dd>
 <dt><code>UnknownError</code></dt>
 <dd>A non-security related error occurred that cannot otherwise be categorized. Recording stops, the <code>MediaRecorder</code>'s {{domxref("MediaRecorder.state", "state")}} becomes <code>inactive</code>, one last {{event("dataavailable")}} event is sent to the <code>MediaRecorder</code> with the remaining received data, and finally a {{event("stop")}} event is sent.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Basic_error-handling_example">Basic error-handling example</h3>

<p>This function creates and returns a <code>MediaRecorder</code> for a given {{domxref("MediaStream")}}, configured to buffer data into an array and to watch for errors.</p>

<pre class="brush: js notranslate">function recordStream(stream) {
  let recorder = null;
  let bufferList = [];

  try {
    recorder = new MediaRecorder(stream);
  } catch(err) {
    /* exception while trying to create the recorder; handle that */
  }

  recorder.ondataavailable = function(event) {
    bufferList.push(event.data);
  };

  recorder.onerror = function(event) {
    let error = event.error;
  };

  recorder.start(100);  /* 100ms time slices per buffer */
  return recorder;
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('MediaStream Recording', '#errorevent-section', 'MediaRecorderErrorEvent.error') }}</td>
   <td>{{ Spec2('MediaStream Recording') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">
<p>The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>
</div>

<p>{{Compat("api.MediaRecorderErrorEvent.error")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/MediaStream_Recording_API">MediaStream Recording API</a></li>
 <li><a href="/en-US/docs/Web/API/MediaStream_Recording_API/Using_the_MediaStream_Recording_API">Using the MediaStream Recording API</a></li>
</ul>
